// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from py_trees_ros_interfaces:msg/SnapshotStreamParameters.idl
// generated code does not contain a copyright notice

#ifndef PY_TREES_ROS_INTERFACES__MSG__DETAIL__SNAPSHOT_STREAM_PARAMETERS__TRAITS_HPP_
#define PY_TREES_ROS_INTERFACES__MSG__DETAIL__SNAPSHOT_STREAM_PARAMETERS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "py_trees_ros_interfaces/msg/detail/snapshot_stream_parameters__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace py_trees_ros_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const SnapshotStreamParameters & msg,
  std::ostream & out)
{
  out << "{";
  // member: snapshot_period
  {
    out << "snapshot_period: ";
    rosidl_generator_traits::value_to_yaml(msg.snapshot_period, out);
    out << ", ";
  }

  // member: blackboard_data
  {
    out << "blackboard_data: ";
    rosidl_generator_traits::value_to_yaml(msg.blackboard_data, out);
    out << ", ";
  }

  // member: blackboard_activity
  {
    out << "blackboard_activity: ";
    rosidl_generator_traits::value_to_yaml(msg.blackboard_activity, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SnapshotStreamParameters & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: snapshot_period
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "snapshot_period: ";
    rosidl_generator_traits::value_to_yaml(msg.snapshot_period, out);
    out << "\n";
  }

  // member: blackboard_data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "blackboard_data: ";
    rosidl_generator_traits::value_to_yaml(msg.blackboard_data, out);
    out << "\n";
  }

  // member: blackboard_activity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "blackboard_activity: ";
    rosidl_generator_traits::value_to_yaml(msg.blackboard_activity, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SnapshotStreamParameters & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace py_trees_ros_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use py_trees_ros_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const py_trees_ros_interfaces::msg::SnapshotStreamParameters & msg,
  std::ostream & out, size_t indentation = 0)
{
  py_trees_ros_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use py_trees_ros_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const py_trees_ros_interfaces::msg::SnapshotStreamParameters & msg)
{
  return py_trees_ros_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<py_trees_ros_interfaces::msg::SnapshotStreamParameters>()
{
  return "py_trees_ros_interfaces::msg::SnapshotStreamParameters";
}

template<>
inline const char * name<py_trees_ros_interfaces::msg::SnapshotStreamParameters>()
{
  return "py_trees_ros_interfaces/msg/SnapshotStreamParameters";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::msg::SnapshotStreamParameters>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::msg::SnapshotStreamParameters>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<py_trees_ros_interfaces::msg::SnapshotStreamParameters>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PY_TREES_ROS_INTERFACES__MSG__DETAIL__SNAPSHOT_STREAM_PARAMETERS__TRAITS_HPP_
