// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from py_trees_ros_interfaces:srv/OpenBlackboardStream.idl
// generated code does not contain a copyright notice

#ifndef PY_TREES_ROS_INTERFACES__SRV__DETAIL__OPEN_BLACKBOARD_STREAM__TRAITS_HPP_
#define PY_TREES_ROS_INTERFACES__SRV__DETAIL__OPEN_BLACKBOARD_STREAM__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "py_trees_ros_interfaces/srv/detail/open_blackboard_stream__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace py_trees_ros_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const OpenBlackboardStream_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: variables
  {
    if (msg.variables.size() == 0) {
      out << "variables: []";
    } else {
      out << "variables: [";
      size_t pending_items = msg.variables.size();
      for (auto item : msg.variables) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: filter_on_visited_path
  {
    out << "filter_on_visited_path: ";
    rosidl_generator_traits::value_to_yaml(msg.filter_on_visited_path, out);
    out << ", ";
  }

  // member: with_activity_stream
  {
    out << "with_activity_stream: ";
    rosidl_generator_traits::value_to_yaml(msg.with_activity_stream, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const OpenBlackboardStream_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: variables
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.variables.size() == 0) {
      out << "variables: []\n";
    } else {
      out << "variables:\n";
      for (auto item : msg.variables) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: filter_on_visited_path
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "filter_on_visited_path: ";
    rosidl_generator_traits::value_to_yaml(msg.filter_on_visited_path, out);
    out << "\n";
  }

  // member: with_activity_stream
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "with_activity_stream: ";
    rosidl_generator_traits::value_to_yaml(msg.with_activity_stream, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const OpenBlackboardStream_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace py_trees_ros_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use py_trees_ros_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const py_trees_ros_interfaces::srv::OpenBlackboardStream_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  py_trees_ros_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use py_trees_ros_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const py_trees_ros_interfaces::srv::OpenBlackboardStream_Request & msg)
{
  return py_trees_ros_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<py_trees_ros_interfaces::srv::OpenBlackboardStream_Request>()
{
  return "py_trees_ros_interfaces::srv::OpenBlackboardStream_Request";
}

template<>
inline const char * name<py_trees_ros_interfaces::srv::OpenBlackboardStream_Request>()
{
  return "py_trees_ros_interfaces/srv/OpenBlackboardStream_Request";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::srv::OpenBlackboardStream_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::srv::OpenBlackboardStream_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<py_trees_ros_interfaces::srv::OpenBlackboardStream_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace py_trees_ros_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const OpenBlackboardStream_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: topic
  {
    out << "topic: ";
    rosidl_generator_traits::value_to_yaml(msg.topic, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const OpenBlackboardStream_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: topic
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "topic: ";
    rosidl_generator_traits::value_to_yaml(msg.topic, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const OpenBlackboardStream_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace py_trees_ros_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use py_trees_ros_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const py_trees_ros_interfaces::srv::OpenBlackboardStream_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  py_trees_ros_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use py_trees_ros_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const py_trees_ros_interfaces::srv::OpenBlackboardStream_Response & msg)
{
  return py_trees_ros_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<py_trees_ros_interfaces::srv::OpenBlackboardStream_Response>()
{
  return "py_trees_ros_interfaces::srv::OpenBlackboardStream_Response";
}

template<>
inline const char * name<py_trees_ros_interfaces::srv::OpenBlackboardStream_Response>()
{
  return "py_trees_ros_interfaces/srv/OpenBlackboardStream_Response";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::srv::OpenBlackboardStream_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::srv::OpenBlackboardStream_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<py_trees_ros_interfaces::srv::OpenBlackboardStream_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<py_trees_ros_interfaces::srv::OpenBlackboardStream>()
{
  return "py_trees_ros_interfaces::srv::OpenBlackboardStream";
}

template<>
inline const char * name<py_trees_ros_interfaces::srv::OpenBlackboardStream>()
{
  return "py_trees_ros_interfaces/srv/OpenBlackboardStream";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::srv::OpenBlackboardStream>
  : std::integral_constant<
    bool,
    has_fixed_size<py_trees_ros_interfaces::srv::OpenBlackboardStream_Request>::value &&
    has_fixed_size<py_trees_ros_interfaces::srv::OpenBlackboardStream_Response>::value
  >
{
};

template<>
struct has_bounded_size<py_trees_ros_interfaces::srv::OpenBlackboardStream>
  : std::integral_constant<
    bool,
    has_bounded_size<py_trees_ros_interfaces::srv::OpenBlackboardStream_Request>::value &&
    has_bounded_size<py_trees_ros_interfaces::srv::OpenBlackboardStream_Response>::value
  >
{
};

template<>
struct is_service<py_trees_ros_interfaces::srv::OpenBlackboardStream>
  : std::true_type
{
};

template<>
struct is_service_request<py_trees_ros_interfaces::srv::OpenBlackboardStream_Request>
  : std::true_type
{
};

template<>
struct is_service_response<py_trees_ros_interfaces::srv::OpenBlackboardStream_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // PY_TREES_ROS_INTERFACES__SRV__DETAIL__OPEN_BLACKBOARD_STREAM__TRAITS_HPP_
