// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from py_trees_ros_interfaces:srv/OpenSnapshotStream.idl
// generated code does not contain a copyright notice
#include "py_trees_ros_interfaces/srv/detail/open_snapshot_stream__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

// Include directives for member types
// Member `topic_name`
#include "rosidl_runtime_c/string_functions.h"
// Member `parameters`
#include "py_trees_ros_interfaces/msg/detail/snapshot_stream_parameters__functions.h"

bool
py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__init(py_trees_ros_interfaces__srv__OpenSnapshotStream_Request * msg)
{
  if (!msg) {
    return false;
  }
  // topic_name
  if (!rosidl_runtime_c__String__init(&msg->topic_name)) {
    py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__fini(msg);
    return false;
  }
  // parameters
  if (!py_trees_ros_interfaces__msg__SnapshotStreamParameters__init(&msg->parameters)) {
    py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__fini(msg);
    return false;
  }
  return true;
}

void
py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__fini(py_trees_ros_interfaces__srv__OpenSnapshotStream_Request * msg)
{
  if (!msg) {
    return;
  }
  // topic_name
  rosidl_runtime_c__String__fini(&msg->topic_name);
  // parameters
  py_trees_ros_interfaces__msg__SnapshotStreamParameters__fini(&msg->parameters);
}

bool
py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__are_equal(const py_trees_ros_interfaces__srv__OpenSnapshotStream_Request * lhs, const py_trees_ros_interfaces__srv__OpenSnapshotStream_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // topic_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->topic_name), &(rhs->topic_name)))
  {
    return false;
  }
  // parameters
  if (!py_trees_ros_interfaces__msg__SnapshotStreamParameters__are_equal(
      &(lhs->parameters), &(rhs->parameters)))
  {
    return false;
  }
  return true;
}

bool
py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__copy(
  const py_trees_ros_interfaces__srv__OpenSnapshotStream_Request * input,
  py_trees_ros_interfaces__srv__OpenSnapshotStream_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // topic_name
  if (!rosidl_runtime_c__String__copy(
      &(input->topic_name), &(output->topic_name)))
  {
    return false;
  }
  // parameters
  if (!py_trees_ros_interfaces__msg__SnapshotStreamParameters__copy(
      &(input->parameters), &(output->parameters)))
  {
    return false;
  }
  return true;
}

py_trees_ros_interfaces__srv__OpenSnapshotStream_Request *
py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  py_trees_ros_interfaces__srv__OpenSnapshotStream_Request * msg = (py_trees_ros_interfaces__srv__OpenSnapshotStream_Request *)allocator.allocate(sizeof(py_trees_ros_interfaces__srv__OpenSnapshotStream_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(py_trees_ros_interfaces__srv__OpenSnapshotStream_Request));
  bool success = py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__destroy(py_trees_ros_interfaces__srv__OpenSnapshotStream_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__Sequence__init(py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  py_trees_ros_interfaces__srv__OpenSnapshotStream_Request * data = NULL;

  if (size) {
    data = (py_trees_ros_interfaces__srv__OpenSnapshotStream_Request *)allocator.zero_allocate(size, sizeof(py_trees_ros_interfaces__srv__OpenSnapshotStream_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__Sequence__fini(py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__Sequence *
py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__Sequence * array = (py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__Sequence *)allocator.allocate(sizeof(py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__Sequence__destroy(py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__Sequence__are_equal(const py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__Sequence * lhs, const py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__Sequence__copy(
  const py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__Sequence * input,
  py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(py_trees_ros_interfaces__srv__OpenSnapshotStream_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    py_trees_ros_interfaces__srv__OpenSnapshotStream_Request * data =
      (py_trees_ros_interfaces__srv__OpenSnapshotStream_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!py_trees_ros_interfaces__srv__OpenSnapshotStream_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `topic_name`
// already included above
// #include "rosidl_runtime_c/string_functions.h"

bool
py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__init(py_trees_ros_interfaces__srv__OpenSnapshotStream_Response * msg)
{
  if (!msg) {
    return false;
  }
  // topic_name
  if (!rosidl_runtime_c__String__init(&msg->topic_name)) {
    py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__fini(msg);
    return false;
  }
  return true;
}

void
py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__fini(py_trees_ros_interfaces__srv__OpenSnapshotStream_Response * msg)
{
  if (!msg) {
    return;
  }
  // topic_name
  rosidl_runtime_c__String__fini(&msg->topic_name);
}

bool
py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__are_equal(const py_trees_ros_interfaces__srv__OpenSnapshotStream_Response * lhs, const py_trees_ros_interfaces__srv__OpenSnapshotStream_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // topic_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->topic_name), &(rhs->topic_name)))
  {
    return false;
  }
  return true;
}

bool
py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__copy(
  const py_trees_ros_interfaces__srv__OpenSnapshotStream_Response * input,
  py_trees_ros_interfaces__srv__OpenSnapshotStream_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // topic_name
  if (!rosidl_runtime_c__String__copy(
      &(input->topic_name), &(output->topic_name)))
  {
    return false;
  }
  return true;
}

py_trees_ros_interfaces__srv__OpenSnapshotStream_Response *
py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  py_trees_ros_interfaces__srv__OpenSnapshotStream_Response * msg = (py_trees_ros_interfaces__srv__OpenSnapshotStream_Response *)allocator.allocate(sizeof(py_trees_ros_interfaces__srv__OpenSnapshotStream_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(py_trees_ros_interfaces__srv__OpenSnapshotStream_Response));
  bool success = py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__destroy(py_trees_ros_interfaces__srv__OpenSnapshotStream_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__Sequence__init(py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  py_trees_ros_interfaces__srv__OpenSnapshotStream_Response * data = NULL;

  if (size) {
    data = (py_trees_ros_interfaces__srv__OpenSnapshotStream_Response *)allocator.zero_allocate(size, sizeof(py_trees_ros_interfaces__srv__OpenSnapshotStream_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__Sequence__fini(py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__Sequence *
py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__Sequence * array = (py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__Sequence *)allocator.allocate(sizeof(py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__Sequence__destroy(py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__Sequence__are_equal(const py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__Sequence * lhs, const py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__Sequence__copy(
  const py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__Sequence * input,
  py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(py_trees_ros_interfaces__srv__OpenSnapshotStream_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    py_trees_ros_interfaces__srv__OpenSnapshotStream_Response * data =
      (py_trees_ros_interfaces__srv__OpenSnapshotStream_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!py_trees_ros_interfaces__srv__OpenSnapshotStream_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
