// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from py_trees_ros_interfaces:action/MoveBase.idl
// generated code does not contain a copyright notice

#ifndef PY_TREES_ROS_INTERFACES__ACTION__DETAIL__MOVE_BASE__STRUCT_H_
#define PY_TREES_ROS_INTERFACES__ACTION__DETAIL__MOVE_BASE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'target_pose'
#include "geometry_msgs/msg/detail/pose_stamped__struct.h"

/// Struct defined in action/MoveBase in the package py_trees_ros_interfaces.
typedef struct py_trees_ros_interfaces__action__MoveBase_Goal
{
  /// Goal
  geometry_msgs__msg__PoseStamped target_pose;
} py_trees_ros_interfaces__action__MoveBase_Goal;

// Struct for a sequence of py_trees_ros_interfaces__action__MoveBase_Goal.
typedef struct py_trees_ros_interfaces__action__MoveBase_Goal__Sequence
{
  py_trees_ros_interfaces__action__MoveBase_Goal * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} py_trees_ros_interfaces__action__MoveBase_Goal__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'message'
#include "rosidl_runtime_c/string.h"

/// Struct defined in action/MoveBase in the package py_trees_ros_interfaces.
typedef struct py_trees_ros_interfaces__action__MoveBase_Result
{
  rosidl_runtime_c__String message;
} py_trees_ros_interfaces__action__MoveBase_Result;

// Struct for a sequence of py_trees_ros_interfaces__action__MoveBase_Result.
typedef struct py_trees_ros_interfaces__action__MoveBase_Result__Sequence
{
  py_trees_ros_interfaces__action__MoveBase_Result * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} py_trees_ros_interfaces__action__MoveBase_Result__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'base_position'
// already included above
// #include "geometry_msgs/msg/detail/pose_stamped__struct.h"

/// Struct defined in action/MoveBase in the package py_trees_ros_interfaces.
typedef struct py_trees_ros_interfaces__action__MoveBase_Feedback
{
  /// Feedback
  geometry_msgs__msg__PoseStamped base_position;
} py_trees_ros_interfaces__action__MoveBase_Feedback;

// Struct for a sequence of py_trees_ros_interfaces__action__MoveBase_Feedback.
typedef struct py_trees_ros_interfaces__action__MoveBase_Feedback__Sequence
{
  py_trees_ros_interfaces__action__MoveBase_Feedback * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} py_trees_ros_interfaces__action__MoveBase_Feedback__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'goal'
#include "py_trees_ros_interfaces/action/detail/move_base__struct.h"

/// Struct defined in action/MoveBase in the package py_trees_ros_interfaces.
typedef struct py_trees_ros_interfaces__action__MoveBase_SendGoal_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
  py_trees_ros_interfaces__action__MoveBase_Goal goal;
} py_trees_ros_interfaces__action__MoveBase_SendGoal_Request;

// Struct for a sequence of py_trees_ros_interfaces__action__MoveBase_SendGoal_Request.
typedef struct py_trees_ros_interfaces__action__MoveBase_SendGoal_Request__Sequence
{
  py_trees_ros_interfaces__action__MoveBase_SendGoal_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} py_trees_ros_interfaces__action__MoveBase_SendGoal_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.h"

/// Struct defined in action/MoveBase in the package py_trees_ros_interfaces.
typedef struct py_trees_ros_interfaces__action__MoveBase_SendGoal_Response
{
  bool accepted;
  builtin_interfaces__msg__Time stamp;
} py_trees_ros_interfaces__action__MoveBase_SendGoal_Response;

// Struct for a sequence of py_trees_ros_interfaces__action__MoveBase_SendGoal_Response.
typedef struct py_trees_ros_interfaces__action__MoveBase_SendGoal_Response__Sequence
{
  py_trees_ros_interfaces__action__MoveBase_SendGoal_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} py_trees_ros_interfaces__action__MoveBase_SendGoal_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"

/// Struct defined in action/MoveBase in the package py_trees_ros_interfaces.
typedef struct py_trees_ros_interfaces__action__MoveBase_GetResult_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
} py_trees_ros_interfaces__action__MoveBase_GetResult_Request;

// Struct for a sequence of py_trees_ros_interfaces__action__MoveBase_GetResult_Request.
typedef struct py_trees_ros_interfaces__action__MoveBase_GetResult_Request__Sequence
{
  py_trees_ros_interfaces__action__MoveBase_GetResult_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} py_trees_ros_interfaces__action__MoveBase_GetResult_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'result'
// already included above
// #include "py_trees_ros_interfaces/action/detail/move_base__struct.h"

/// Struct defined in action/MoveBase in the package py_trees_ros_interfaces.
typedef struct py_trees_ros_interfaces__action__MoveBase_GetResult_Response
{
  int8_t status;
  py_trees_ros_interfaces__action__MoveBase_Result result;
} py_trees_ros_interfaces__action__MoveBase_GetResult_Response;

// Struct for a sequence of py_trees_ros_interfaces__action__MoveBase_GetResult_Response.
typedef struct py_trees_ros_interfaces__action__MoveBase_GetResult_Response__Sequence
{
  py_trees_ros_interfaces__action__MoveBase_GetResult_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} py_trees_ros_interfaces__action__MoveBase_GetResult_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'feedback'
// already included above
// #include "py_trees_ros_interfaces/action/detail/move_base__struct.h"

/// Struct defined in action/MoveBase in the package py_trees_ros_interfaces.
typedef struct py_trees_ros_interfaces__action__MoveBase_FeedbackMessage
{
  unique_identifier_msgs__msg__UUID goal_id;
  py_trees_ros_interfaces__action__MoveBase_Feedback feedback;
} py_trees_ros_interfaces__action__MoveBase_FeedbackMessage;

// Struct for a sequence of py_trees_ros_interfaces__action__MoveBase_FeedbackMessage.
typedef struct py_trees_ros_interfaces__action__MoveBase_FeedbackMessage__Sequence
{
  py_trees_ros_interfaces__action__MoveBase_FeedbackMessage * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} py_trees_ros_interfaces__action__MoveBase_FeedbackMessage__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // PY_TREES_ROS_INTERFACES__ACTION__DETAIL__MOVE_BASE__STRUCT_H_
