// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from py_trees_ros_interfaces:action/Rotate.idl
// generated code does not contain a copyright notice

#ifndef PY_TREES_ROS_INTERFACES__ACTION__DETAIL__ROTATE__TRAITS_HPP_
#define PY_TREES_ROS_INTERFACES__ACTION__DETAIL__ROTATE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "py_trees_ros_interfaces/action/detail/rotate__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace py_trees_ros_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const Rotate_Goal & msg,
  std::ostream & out)
{
  (void)msg;
  out << "null";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Rotate_Goal & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Rotate_Goal & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace py_trees_ros_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use py_trees_ros_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const py_trees_ros_interfaces::action::Rotate_Goal & msg,
  std::ostream & out, size_t indentation = 0)
{
  py_trees_ros_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use py_trees_ros_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const py_trees_ros_interfaces::action::Rotate_Goal & msg)
{
  return py_trees_ros_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<py_trees_ros_interfaces::action::Rotate_Goal>()
{
  return "py_trees_ros_interfaces::action::Rotate_Goal";
}

template<>
inline const char * name<py_trees_ros_interfaces::action::Rotate_Goal>()
{
  return "py_trees_ros_interfaces/action/Rotate_Goal";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::action::Rotate_Goal>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::action::Rotate_Goal>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<py_trees_ros_interfaces::action::Rotate_Goal>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace py_trees_ros_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const Rotate_Result & msg,
  std::ostream & out)
{
  out << "{";
  // member: message
  {
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Rotate_Result & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: message
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Rotate_Result & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace py_trees_ros_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use py_trees_ros_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const py_trees_ros_interfaces::action::Rotate_Result & msg,
  std::ostream & out, size_t indentation = 0)
{
  py_trees_ros_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use py_trees_ros_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const py_trees_ros_interfaces::action::Rotate_Result & msg)
{
  return py_trees_ros_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<py_trees_ros_interfaces::action::Rotate_Result>()
{
  return "py_trees_ros_interfaces::action::Rotate_Result";
}

template<>
inline const char * name<py_trees_ros_interfaces::action::Rotate_Result>()
{
  return "py_trees_ros_interfaces/action/Rotate_Result";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::action::Rotate_Result>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::action::Rotate_Result>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<py_trees_ros_interfaces::action::Rotate_Result>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace py_trees_ros_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const Rotate_Feedback & msg,
  std::ostream & out)
{
  out << "{";
  // member: percentage_completed
  {
    out << "percentage_completed: ";
    rosidl_generator_traits::value_to_yaml(msg.percentage_completed, out);
    out << ", ";
  }

  // member: angle_rotated
  {
    out << "angle_rotated: ";
    rosidl_generator_traits::value_to_yaml(msg.angle_rotated, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Rotate_Feedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: percentage_completed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "percentage_completed: ";
    rosidl_generator_traits::value_to_yaml(msg.percentage_completed, out);
    out << "\n";
  }

  // member: angle_rotated
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "angle_rotated: ";
    rosidl_generator_traits::value_to_yaml(msg.angle_rotated, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Rotate_Feedback & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace py_trees_ros_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use py_trees_ros_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const py_trees_ros_interfaces::action::Rotate_Feedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  py_trees_ros_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use py_trees_ros_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const py_trees_ros_interfaces::action::Rotate_Feedback & msg)
{
  return py_trees_ros_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<py_trees_ros_interfaces::action::Rotate_Feedback>()
{
  return "py_trees_ros_interfaces::action::Rotate_Feedback";
}

template<>
inline const char * name<py_trees_ros_interfaces::action::Rotate_Feedback>()
{
  return "py_trees_ros_interfaces/action/Rotate_Feedback";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::action::Rotate_Feedback>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::action::Rotate_Feedback>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<py_trees_ros_interfaces::action::Rotate_Feedback>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'goal'
#include "py_trees_ros_interfaces/action/detail/rotate__traits.hpp"

namespace py_trees_ros_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const Rotate_SendGoal_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
    out << ", ";
  }

  // member: goal
  {
    out << "goal: ";
    to_flow_style_yaml(msg.goal, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Rotate_SendGoal_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: goal
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal:\n";
    to_block_style_yaml(msg.goal, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Rotate_SendGoal_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace py_trees_ros_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use py_trees_ros_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const py_trees_ros_interfaces::action::Rotate_SendGoal_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  py_trees_ros_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use py_trees_ros_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const py_trees_ros_interfaces::action::Rotate_SendGoal_Request & msg)
{
  return py_trees_ros_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<py_trees_ros_interfaces::action::Rotate_SendGoal_Request>()
{
  return "py_trees_ros_interfaces::action::Rotate_SendGoal_Request";
}

template<>
inline const char * name<py_trees_ros_interfaces::action::Rotate_SendGoal_Request>()
{
  return "py_trees_ros_interfaces/action/Rotate_SendGoal_Request";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::action::Rotate_SendGoal_Request>
  : std::integral_constant<bool, has_fixed_size<py_trees_ros_interfaces::action::Rotate_Goal>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::action::Rotate_SendGoal_Request>
  : std::integral_constant<bool, has_bounded_size<py_trees_ros_interfaces::action::Rotate_Goal>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<py_trees_ros_interfaces::action::Rotate_SendGoal_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace py_trees_ros_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const Rotate_SendGoal_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: accepted
  {
    out << "accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.accepted, out);
    out << ", ";
  }

  // member: stamp
  {
    out << "stamp: ";
    to_flow_style_yaml(msg.stamp, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Rotate_SendGoal_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: accepted
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.accepted, out);
    out << "\n";
  }

  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp:\n";
    to_block_style_yaml(msg.stamp, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Rotate_SendGoal_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace py_trees_ros_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use py_trees_ros_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const py_trees_ros_interfaces::action::Rotate_SendGoal_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  py_trees_ros_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use py_trees_ros_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const py_trees_ros_interfaces::action::Rotate_SendGoal_Response & msg)
{
  return py_trees_ros_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<py_trees_ros_interfaces::action::Rotate_SendGoal_Response>()
{
  return "py_trees_ros_interfaces::action::Rotate_SendGoal_Response";
}

template<>
inline const char * name<py_trees_ros_interfaces::action::Rotate_SendGoal_Response>()
{
  return "py_trees_ros_interfaces/action/Rotate_SendGoal_Response";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::action::Rotate_SendGoal_Response>
  : std::integral_constant<bool, has_fixed_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::action::Rotate_SendGoal_Response>
  : std::integral_constant<bool, has_bounded_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct is_message<py_trees_ros_interfaces::action::Rotate_SendGoal_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<py_trees_ros_interfaces::action::Rotate_SendGoal>()
{
  return "py_trees_ros_interfaces::action::Rotate_SendGoal";
}

template<>
inline const char * name<py_trees_ros_interfaces::action::Rotate_SendGoal>()
{
  return "py_trees_ros_interfaces/action/Rotate_SendGoal";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::action::Rotate_SendGoal>
  : std::integral_constant<
    bool,
    has_fixed_size<py_trees_ros_interfaces::action::Rotate_SendGoal_Request>::value &&
    has_fixed_size<py_trees_ros_interfaces::action::Rotate_SendGoal_Response>::value
  >
{
};

template<>
struct has_bounded_size<py_trees_ros_interfaces::action::Rotate_SendGoal>
  : std::integral_constant<
    bool,
    has_bounded_size<py_trees_ros_interfaces::action::Rotate_SendGoal_Request>::value &&
    has_bounded_size<py_trees_ros_interfaces::action::Rotate_SendGoal_Response>::value
  >
{
};

template<>
struct is_service<py_trees_ros_interfaces::action::Rotate_SendGoal>
  : std::true_type
{
};

template<>
struct is_service_request<py_trees_ros_interfaces::action::Rotate_SendGoal_Request>
  : std::true_type
{
};

template<>
struct is_service_response<py_trees_ros_interfaces::action::Rotate_SendGoal_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"

namespace py_trees_ros_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const Rotate_GetResult_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Rotate_GetResult_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Rotate_GetResult_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace py_trees_ros_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use py_trees_ros_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const py_trees_ros_interfaces::action::Rotate_GetResult_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  py_trees_ros_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use py_trees_ros_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const py_trees_ros_interfaces::action::Rotate_GetResult_Request & msg)
{
  return py_trees_ros_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<py_trees_ros_interfaces::action::Rotate_GetResult_Request>()
{
  return "py_trees_ros_interfaces::action::Rotate_GetResult_Request";
}

template<>
inline const char * name<py_trees_ros_interfaces::action::Rotate_GetResult_Request>()
{
  return "py_trees_ros_interfaces/action/Rotate_GetResult_Request";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::action::Rotate_GetResult_Request>
  : std::integral_constant<bool, has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::action::Rotate_GetResult_Request>
  : std::integral_constant<bool, has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<py_trees_ros_interfaces::action::Rotate_GetResult_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'result'
// already included above
// #include "py_trees_ros_interfaces/action/detail/rotate__traits.hpp"

namespace py_trees_ros_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const Rotate_GetResult_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: status
  {
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << ", ";
  }

  // member: result
  {
    out << "result: ";
    to_flow_style_yaml(msg.result, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Rotate_GetResult_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << "\n";
  }

  // member: result
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "result:\n";
    to_block_style_yaml(msg.result, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Rotate_GetResult_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace py_trees_ros_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use py_trees_ros_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const py_trees_ros_interfaces::action::Rotate_GetResult_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  py_trees_ros_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use py_trees_ros_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const py_trees_ros_interfaces::action::Rotate_GetResult_Response & msg)
{
  return py_trees_ros_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<py_trees_ros_interfaces::action::Rotate_GetResult_Response>()
{
  return "py_trees_ros_interfaces::action::Rotate_GetResult_Response";
}

template<>
inline const char * name<py_trees_ros_interfaces::action::Rotate_GetResult_Response>()
{
  return "py_trees_ros_interfaces/action/Rotate_GetResult_Response";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::action::Rotate_GetResult_Response>
  : std::integral_constant<bool, has_fixed_size<py_trees_ros_interfaces::action::Rotate_Result>::value> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::action::Rotate_GetResult_Response>
  : std::integral_constant<bool, has_bounded_size<py_trees_ros_interfaces::action::Rotate_Result>::value> {};

template<>
struct is_message<py_trees_ros_interfaces::action::Rotate_GetResult_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<py_trees_ros_interfaces::action::Rotate_GetResult>()
{
  return "py_trees_ros_interfaces::action::Rotate_GetResult";
}

template<>
inline const char * name<py_trees_ros_interfaces::action::Rotate_GetResult>()
{
  return "py_trees_ros_interfaces/action/Rotate_GetResult";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::action::Rotate_GetResult>
  : std::integral_constant<
    bool,
    has_fixed_size<py_trees_ros_interfaces::action::Rotate_GetResult_Request>::value &&
    has_fixed_size<py_trees_ros_interfaces::action::Rotate_GetResult_Response>::value
  >
{
};

template<>
struct has_bounded_size<py_trees_ros_interfaces::action::Rotate_GetResult>
  : std::integral_constant<
    bool,
    has_bounded_size<py_trees_ros_interfaces::action::Rotate_GetResult_Request>::value &&
    has_bounded_size<py_trees_ros_interfaces::action::Rotate_GetResult_Response>::value
  >
{
};

template<>
struct is_service<py_trees_ros_interfaces::action::Rotate_GetResult>
  : std::true_type
{
};

template<>
struct is_service_request<py_trees_ros_interfaces::action::Rotate_GetResult_Request>
  : std::true_type
{
};

template<>
struct is_service_response<py_trees_ros_interfaces::action::Rotate_GetResult_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'feedback'
// already included above
// #include "py_trees_ros_interfaces/action/detail/rotate__traits.hpp"

namespace py_trees_ros_interfaces
{

namespace action
{

inline void to_flow_style_yaml(
  const Rotate_FeedbackMessage & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
    out << ", ";
  }

  // member: feedback
  {
    out << "feedback: ";
    to_flow_style_yaml(msg.feedback, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Rotate_FeedbackMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: feedback
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "feedback:\n";
    to_block_style_yaml(msg.feedback, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Rotate_FeedbackMessage & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace py_trees_ros_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use py_trees_ros_interfaces::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const py_trees_ros_interfaces::action::Rotate_FeedbackMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  py_trees_ros_interfaces::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use py_trees_ros_interfaces::action::to_yaml() instead")]]
inline std::string to_yaml(const py_trees_ros_interfaces::action::Rotate_FeedbackMessage & msg)
{
  return py_trees_ros_interfaces::action::to_yaml(msg);
}

template<>
inline const char * data_type<py_trees_ros_interfaces::action::Rotate_FeedbackMessage>()
{
  return "py_trees_ros_interfaces::action::Rotate_FeedbackMessage";
}

template<>
inline const char * name<py_trees_ros_interfaces::action::Rotate_FeedbackMessage>()
{
  return "py_trees_ros_interfaces/action/Rotate_FeedbackMessage";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::action::Rotate_FeedbackMessage>
  : std::integral_constant<bool, has_fixed_size<py_trees_ros_interfaces::action::Rotate_Feedback>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::action::Rotate_FeedbackMessage>
  : std::integral_constant<bool, has_bounded_size<py_trees_ros_interfaces::action::Rotate_Feedback>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<py_trees_ros_interfaces::action::Rotate_FeedbackMessage>
  : std::true_type {};

}  // namespace rosidl_generator_traits


namespace rosidl_generator_traits
{

template<>
struct is_action<py_trees_ros_interfaces::action::Rotate>
  : std::true_type
{
};

template<>
struct is_action_goal<py_trees_ros_interfaces::action::Rotate_Goal>
  : std::true_type
{
};

template<>
struct is_action_result<py_trees_ros_interfaces::action::Rotate_Result>
  : std::true_type
{
};

template<>
struct is_action_feedback<py_trees_ros_interfaces::action::Rotate_Feedback>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits


#endif  // PY_TREES_ROS_INTERFACES__ACTION__DETAIL__ROTATE__TRAITS_HPP_
