// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from py_trees_ros_interfaces:msg/BehaviourTree.idl
// generated code does not contain a copyright notice

#ifndef PY_TREES_ROS_INTERFACES__MSG__DETAIL__BEHAVIOUR_TREE__TRAITS_HPP_
#define PY_TREES_ROS_INTERFACES__MSG__DETAIL__BEHAVIOUR_TREE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "py_trees_ros_interfaces/msg/detail/behaviour_tree__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'behaviours'
#include "py_trees_ros_interfaces/msg/detail/behaviour__traits.hpp"
// Member 'blackboard_on_visited_path'
#include "diagnostic_msgs/msg/detail/key_value__traits.hpp"
// Member 'blackboard_activity'
#include "py_trees_ros_interfaces/msg/detail/activity_item__traits.hpp"
// Member 'statistics'
#include "py_trees_ros_interfaces/msg/detail/statistics__traits.hpp"

namespace py_trees_ros_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const BehaviourTree & msg,
  std::ostream & out)
{
  out << "{";
  // member: behaviours
  {
    if (msg.behaviours.size() == 0) {
      out << "behaviours: []";
    } else {
      out << "behaviours: [";
      size_t pending_items = msg.behaviours.size();
      for (auto item : msg.behaviours) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: changed
  {
    out << "changed: ";
    rosidl_generator_traits::value_to_yaml(msg.changed, out);
    out << ", ";
  }

  // member: blackboard_on_visited_path
  {
    if (msg.blackboard_on_visited_path.size() == 0) {
      out << "blackboard_on_visited_path: []";
    } else {
      out << "blackboard_on_visited_path: [";
      size_t pending_items = msg.blackboard_on_visited_path.size();
      for (auto item : msg.blackboard_on_visited_path) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: blackboard_activity
  {
    if (msg.blackboard_activity.size() == 0) {
      out << "blackboard_activity: []";
    } else {
      out << "blackboard_activity: [";
      size_t pending_items = msg.blackboard_activity.size();
      for (auto item : msg.blackboard_activity) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: statistics
  {
    out << "statistics: ";
    to_flow_style_yaml(msg.statistics, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const BehaviourTree & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: behaviours
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.behaviours.size() == 0) {
      out << "behaviours: []\n";
    } else {
      out << "behaviours:\n";
      for (auto item : msg.behaviours) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: changed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "changed: ";
    rosidl_generator_traits::value_to_yaml(msg.changed, out);
    out << "\n";
  }

  // member: blackboard_on_visited_path
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.blackboard_on_visited_path.size() == 0) {
      out << "blackboard_on_visited_path: []\n";
    } else {
      out << "blackboard_on_visited_path:\n";
      for (auto item : msg.blackboard_on_visited_path) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: blackboard_activity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.blackboard_activity.size() == 0) {
      out << "blackboard_activity: []\n";
    } else {
      out << "blackboard_activity:\n";
      for (auto item : msg.blackboard_activity) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: statistics
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "statistics:\n";
    to_block_style_yaml(msg.statistics, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const BehaviourTree & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace py_trees_ros_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use py_trees_ros_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const py_trees_ros_interfaces::msg::BehaviourTree & msg,
  std::ostream & out, size_t indentation = 0)
{
  py_trees_ros_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use py_trees_ros_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const py_trees_ros_interfaces::msg::BehaviourTree & msg)
{
  return py_trees_ros_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<py_trees_ros_interfaces::msg::BehaviourTree>()
{
  return "py_trees_ros_interfaces::msg::BehaviourTree";
}

template<>
inline const char * name<py_trees_ros_interfaces::msg::BehaviourTree>()
{
  return "py_trees_ros_interfaces/msg/BehaviourTree";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::msg::BehaviourTree>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::msg::BehaviourTree>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<py_trees_ros_interfaces::msg::BehaviourTree>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PY_TREES_ROS_INTERFACES__MSG__DETAIL__BEHAVIOUR_TREE__TRAITS_HPP_
