// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from py_trees_ros_interfaces:msg/ServiceDetails.idl
// generated code does not contain a copyright notice

#ifndef PY_TREES_ROS_INTERFACES__MSG__DETAIL__SERVICE_DETAILS__TRAITS_HPP_
#define PY_TREES_ROS_INTERFACES__MSG__DETAIL__SERVICE_DETAILS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "py_trees_ros_interfaces/msg/detail/service_details__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace py_trees_ros_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const ServiceDetails & msg,
  std::ostream & out)
{
  out << "{";
  // member: service_name
  {
    out << "service_name: ";
    rosidl_generator_traits::value_to_yaml(msg.service_name, out);
    out << ", ";
  }

  // member: service_type
  {
    out << "service_type: ";
    rosidl_generator_traits::value_to_yaml(msg.service_type, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ServiceDetails & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: service_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "service_name: ";
    rosidl_generator_traits::value_to_yaml(msg.service_name, out);
    out << "\n";
  }

  // member: service_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "service_type: ";
    rosidl_generator_traits::value_to_yaml(msg.service_type, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ServiceDetails & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace py_trees_ros_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use py_trees_ros_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const py_trees_ros_interfaces::msg::ServiceDetails & msg,
  std::ostream & out, size_t indentation = 0)
{
  py_trees_ros_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use py_trees_ros_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const py_trees_ros_interfaces::msg::ServiceDetails & msg)
{
  return py_trees_ros_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<py_trees_ros_interfaces::msg::ServiceDetails>()
{
  return "py_trees_ros_interfaces::msg::ServiceDetails";
}

template<>
inline const char * name<py_trees_ros_interfaces::msg::ServiceDetails>()
{
  return "py_trees_ros_interfaces/msg/ServiceDetails";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::msg::ServiceDetails>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::msg::ServiceDetails>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<py_trees_ros_interfaces::msg::ServiceDetails>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PY_TREES_ROS_INTERFACES__MSG__DETAIL__SERVICE_DETAILS__TRAITS_HPP_
