// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from py_trees_ros_interfaces:msg/Statistics.idl
// generated code does not contain a copyright notice
#include "py_trees_ros_interfaces/msg/detail/statistics__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `stamp`
#include "builtin_interfaces/msg/detail/time__functions.h"

bool
py_trees_ros_interfaces__msg__Statistics__init(py_trees_ros_interfaces__msg__Statistics * msg)
{
  if (!msg) {
    return false;
  }
  // count
  // stamp
  if (!builtin_interfaces__msg__Time__init(&msg->stamp)) {
    py_trees_ros_interfaces__msg__Statistics__fini(msg);
    return false;
  }
  // tick_duration
  // tick_duration_average
  // tick_duration_variance
  // tick_interval
  // tick_interval_average
  // tick_interval_variance
  return true;
}

void
py_trees_ros_interfaces__msg__Statistics__fini(py_trees_ros_interfaces__msg__Statistics * msg)
{
  if (!msg) {
    return;
  }
  // count
  // stamp
  builtin_interfaces__msg__Time__fini(&msg->stamp);
  // tick_duration
  // tick_duration_average
  // tick_duration_variance
  // tick_interval
  // tick_interval_average
  // tick_interval_variance
}

bool
py_trees_ros_interfaces__msg__Statistics__are_equal(const py_trees_ros_interfaces__msg__Statistics * lhs, const py_trees_ros_interfaces__msg__Statistics * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // count
  if (lhs->count != rhs->count) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->stamp), &(rhs->stamp)))
  {
    return false;
  }
  // tick_duration
  if (lhs->tick_duration != rhs->tick_duration) {
    return false;
  }
  // tick_duration_average
  if (lhs->tick_duration_average != rhs->tick_duration_average) {
    return false;
  }
  // tick_duration_variance
  if (lhs->tick_duration_variance != rhs->tick_duration_variance) {
    return false;
  }
  // tick_interval
  if (lhs->tick_interval != rhs->tick_interval) {
    return false;
  }
  // tick_interval_average
  if (lhs->tick_interval_average != rhs->tick_interval_average) {
    return false;
  }
  // tick_interval_variance
  if (lhs->tick_interval_variance != rhs->tick_interval_variance) {
    return false;
  }
  return true;
}

bool
py_trees_ros_interfaces__msg__Statistics__copy(
  const py_trees_ros_interfaces__msg__Statistics * input,
  py_trees_ros_interfaces__msg__Statistics * output)
{
  if (!input || !output) {
    return false;
  }
  // count
  output->count = input->count;
  // stamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->stamp), &(output->stamp)))
  {
    return false;
  }
  // tick_duration
  output->tick_duration = input->tick_duration;
  // tick_duration_average
  output->tick_duration_average = input->tick_duration_average;
  // tick_duration_variance
  output->tick_duration_variance = input->tick_duration_variance;
  // tick_interval
  output->tick_interval = input->tick_interval;
  // tick_interval_average
  output->tick_interval_average = input->tick_interval_average;
  // tick_interval_variance
  output->tick_interval_variance = input->tick_interval_variance;
  return true;
}

py_trees_ros_interfaces__msg__Statistics *
py_trees_ros_interfaces__msg__Statistics__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  py_trees_ros_interfaces__msg__Statistics * msg = (py_trees_ros_interfaces__msg__Statistics *)allocator.allocate(sizeof(py_trees_ros_interfaces__msg__Statistics), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(py_trees_ros_interfaces__msg__Statistics));
  bool success = py_trees_ros_interfaces__msg__Statistics__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
py_trees_ros_interfaces__msg__Statistics__destroy(py_trees_ros_interfaces__msg__Statistics * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    py_trees_ros_interfaces__msg__Statistics__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
py_trees_ros_interfaces__msg__Statistics__Sequence__init(py_trees_ros_interfaces__msg__Statistics__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  py_trees_ros_interfaces__msg__Statistics * data = NULL;

  if (size) {
    data = (py_trees_ros_interfaces__msg__Statistics *)allocator.zero_allocate(size, sizeof(py_trees_ros_interfaces__msg__Statistics), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = py_trees_ros_interfaces__msg__Statistics__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        py_trees_ros_interfaces__msg__Statistics__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
py_trees_ros_interfaces__msg__Statistics__Sequence__fini(py_trees_ros_interfaces__msg__Statistics__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      py_trees_ros_interfaces__msg__Statistics__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

py_trees_ros_interfaces__msg__Statistics__Sequence *
py_trees_ros_interfaces__msg__Statistics__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  py_trees_ros_interfaces__msg__Statistics__Sequence * array = (py_trees_ros_interfaces__msg__Statistics__Sequence *)allocator.allocate(sizeof(py_trees_ros_interfaces__msg__Statistics__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = py_trees_ros_interfaces__msg__Statistics__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
py_trees_ros_interfaces__msg__Statistics__Sequence__destroy(py_trees_ros_interfaces__msg__Statistics__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    py_trees_ros_interfaces__msg__Statistics__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
py_trees_ros_interfaces__msg__Statistics__Sequence__are_equal(const py_trees_ros_interfaces__msg__Statistics__Sequence * lhs, const py_trees_ros_interfaces__msg__Statistics__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!py_trees_ros_interfaces__msg__Statistics__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
py_trees_ros_interfaces__msg__Statistics__Sequence__copy(
  const py_trees_ros_interfaces__msg__Statistics__Sequence * input,
  py_trees_ros_interfaces__msg__Statistics__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(py_trees_ros_interfaces__msg__Statistics);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    py_trees_ros_interfaces__msg__Statistics * data =
      (py_trees_ros_interfaces__msg__Statistics *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!py_trees_ros_interfaces__msg__Statistics__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          py_trees_ros_interfaces__msg__Statistics__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!py_trees_ros_interfaces__msg__Statistics__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
