// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from py_trees_ros_interfaces:msg/Statistics.idl
// generated code does not contain a copyright notice

#ifndef PY_TREES_ROS_INTERFACES__MSG__DETAIL__STATISTICS__TRAITS_HPP_
#define PY_TREES_ROS_INTERFACES__MSG__DETAIL__STATISTICS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "py_trees_ros_interfaces/msg/detail/statistics__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace py_trees_ros_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const Statistics & msg,
  std::ostream & out)
{
  out << "{";
  // member: count
  {
    out << "count: ";
    rosidl_generator_traits::value_to_yaml(msg.count, out);
    out << ", ";
  }

  // member: stamp
  {
    out << "stamp: ";
    to_flow_style_yaml(msg.stamp, out);
    out << ", ";
  }

  // member: tick_duration
  {
    out << "tick_duration: ";
    rosidl_generator_traits::value_to_yaml(msg.tick_duration, out);
    out << ", ";
  }

  // member: tick_duration_average
  {
    out << "tick_duration_average: ";
    rosidl_generator_traits::value_to_yaml(msg.tick_duration_average, out);
    out << ", ";
  }

  // member: tick_duration_variance
  {
    out << "tick_duration_variance: ";
    rosidl_generator_traits::value_to_yaml(msg.tick_duration_variance, out);
    out << ", ";
  }

  // member: tick_interval
  {
    out << "tick_interval: ";
    rosidl_generator_traits::value_to_yaml(msg.tick_interval, out);
    out << ", ";
  }

  // member: tick_interval_average
  {
    out << "tick_interval_average: ";
    rosidl_generator_traits::value_to_yaml(msg.tick_interval_average, out);
    out << ", ";
  }

  // member: tick_interval_variance
  {
    out << "tick_interval_variance: ";
    rosidl_generator_traits::value_to_yaml(msg.tick_interval_variance, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Statistics & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: count
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "count: ";
    rosidl_generator_traits::value_to_yaml(msg.count, out);
    out << "\n";
  }

  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp:\n";
    to_block_style_yaml(msg.stamp, out, indentation + 2);
  }

  // member: tick_duration
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "tick_duration: ";
    rosidl_generator_traits::value_to_yaml(msg.tick_duration, out);
    out << "\n";
  }

  // member: tick_duration_average
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "tick_duration_average: ";
    rosidl_generator_traits::value_to_yaml(msg.tick_duration_average, out);
    out << "\n";
  }

  // member: tick_duration_variance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "tick_duration_variance: ";
    rosidl_generator_traits::value_to_yaml(msg.tick_duration_variance, out);
    out << "\n";
  }

  // member: tick_interval
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "tick_interval: ";
    rosidl_generator_traits::value_to_yaml(msg.tick_interval, out);
    out << "\n";
  }

  // member: tick_interval_average
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "tick_interval_average: ";
    rosidl_generator_traits::value_to_yaml(msg.tick_interval_average, out);
    out << "\n";
  }

  // member: tick_interval_variance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "tick_interval_variance: ";
    rosidl_generator_traits::value_to_yaml(msg.tick_interval_variance, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Statistics & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace py_trees_ros_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use py_trees_ros_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const py_trees_ros_interfaces::msg::Statistics & msg,
  std::ostream & out, size_t indentation = 0)
{
  py_trees_ros_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use py_trees_ros_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const py_trees_ros_interfaces::msg::Statistics & msg)
{
  return py_trees_ros_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<py_trees_ros_interfaces::msg::Statistics>()
{
  return "py_trees_ros_interfaces::msg::Statistics";
}

template<>
inline const char * name<py_trees_ros_interfaces::msg::Statistics>()
{
  return "py_trees_ros_interfaces/msg/Statistics";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::msg::Statistics>
  : std::integral_constant<bool, has_fixed_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::msg::Statistics>
  : std::integral_constant<bool, has_bounded_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct is_message<py_trees_ros_interfaces::msg::Statistics>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PY_TREES_ROS_INTERFACES__MSG__DETAIL__STATISTICS__TRAITS_HPP_
