// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from py_trees_ros_interfaces:srv/CloseSnapshotStream.idl
// generated code does not contain a copyright notice

#ifndef PY_TREES_ROS_INTERFACES__SRV__DETAIL__CLOSE_SNAPSHOT_STREAM__TRAITS_HPP_
#define PY_TREES_ROS_INTERFACES__SRV__DETAIL__CLOSE_SNAPSHOT_STREAM__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "py_trees_ros_interfaces/srv/detail/close_snapshot_stream__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace py_trees_ros_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const CloseSnapshotStream_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: topic_name
  {
    out << "topic_name: ";
    rosidl_generator_traits::value_to_yaml(msg.topic_name, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CloseSnapshotStream_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: topic_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "topic_name: ";
    rosidl_generator_traits::value_to_yaml(msg.topic_name, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CloseSnapshotStream_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace py_trees_ros_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use py_trees_ros_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const py_trees_ros_interfaces::srv::CloseSnapshotStream_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  py_trees_ros_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use py_trees_ros_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const py_trees_ros_interfaces::srv::CloseSnapshotStream_Request & msg)
{
  return py_trees_ros_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<py_trees_ros_interfaces::srv::CloseSnapshotStream_Request>()
{
  return "py_trees_ros_interfaces::srv::CloseSnapshotStream_Request";
}

template<>
inline const char * name<py_trees_ros_interfaces::srv::CloseSnapshotStream_Request>()
{
  return "py_trees_ros_interfaces/srv/CloseSnapshotStream_Request";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::srv::CloseSnapshotStream_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::srv::CloseSnapshotStream_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<py_trees_ros_interfaces::srv::CloseSnapshotStream_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace py_trees_ros_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const CloseSnapshotStream_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: result
  {
    out << "result: ";
    rosidl_generator_traits::value_to_yaml(msg.result, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CloseSnapshotStream_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: result
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "result: ";
    rosidl_generator_traits::value_to_yaml(msg.result, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CloseSnapshotStream_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace py_trees_ros_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use py_trees_ros_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const py_trees_ros_interfaces::srv::CloseSnapshotStream_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  py_trees_ros_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use py_trees_ros_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const py_trees_ros_interfaces::srv::CloseSnapshotStream_Response & msg)
{
  return py_trees_ros_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<py_trees_ros_interfaces::srv::CloseSnapshotStream_Response>()
{
  return "py_trees_ros_interfaces::srv::CloseSnapshotStream_Response";
}

template<>
inline const char * name<py_trees_ros_interfaces::srv::CloseSnapshotStream_Response>()
{
  return "py_trees_ros_interfaces/srv/CloseSnapshotStream_Response";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::srv::CloseSnapshotStream_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::srv::CloseSnapshotStream_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<py_trees_ros_interfaces::srv::CloseSnapshotStream_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<py_trees_ros_interfaces::srv::CloseSnapshotStream>()
{
  return "py_trees_ros_interfaces::srv::CloseSnapshotStream";
}

template<>
inline const char * name<py_trees_ros_interfaces::srv::CloseSnapshotStream>()
{
  return "py_trees_ros_interfaces/srv/CloseSnapshotStream";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::srv::CloseSnapshotStream>
  : std::integral_constant<
    bool,
    has_fixed_size<py_trees_ros_interfaces::srv::CloseSnapshotStream_Request>::value &&
    has_fixed_size<py_trees_ros_interfaces::srv::CloseSnapshotStream_Response>::value
  >
{
};

template<>
struct has_bounded_size<py_trees_ros_interfaces::srv::CloseSnapshotStream>
  : std::integral_constant<
    bool,
    has_bounded_size<py_trees_ros_interfaces::srv::CloseSnapshotStream_Request>::value &&
    has_bounded_size<py_trees_ros_interfaces::srv::CloseSnapshotStream_Response>::value
  >
{
};

template<>
struct is_service<py_trees_ros_interfaces::srv::CloseSnapshotStream>
  : std::true_type
{
};

template<>
struct is_service_request<py_trees_ros_interfaces::srv::CloseSnapshotStream_Request>
  : std::true_type
{
};

template<>
struct is_service_response<py_trees_ros_interfaces::srv::CloseSnapshotStream_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // PY_TREES_ROS_INTERFACES__SRV__DETAIL__CLOSE_SNAPSHOT_STREAM__TRAITS_HPP_
