// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from py_trees_ros_interfaces:srv/IntrospectPublishers.idl
// generated code does not contain a copyright notice

#ifndef PY_TREES_ROS_INTERFACES__SRV__DETAIL__INTROSPECT_PUBLISHERS__TRAITS_HPP_
#define PY_TREES_ROS_INTERFACES__SRV__DETAIL__INTROSPECT_PUBLISHERS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "py_trees_ros_interfaces/srv/detail/introspect_publishers__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace py_trees_ros_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const IntrospectPublishers_Request & msg,
  std::ostream & out)
{
  (void)msg;
  out << "null";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const IntrospectPublishers_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const IntrospectPublishers_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace py_trees_ros_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use py_trees_ros_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const py_trees_ros_interfaces::srv::IntrospectPublishers_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  py_trees_ros_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use py_trees_ros_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const py_trees_ros_interfaces::srv::IntrospectPublishers_Request & msg)
{
  return py_trees_ros_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<py_trees_ros_interfaces::srv::IntrospectPublishers_Request>()
{
  return "py_trees_ros_interfaces::srv::IntrospectPublishers_Request";
}

template<>
inline const char * name<py_trees_ros_interfaces::srv::IntrospectPublishers_Request>()
{
  return "py_trees_ros_interfaces/srv/IntrospectPublishers_Request";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::srv::IntrospectPublishers_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::srv::IntrospectPublishers_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<py_trees_ros_interfaces::srv::IntrospectPublishers_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'publisher_details'
#include "py_trees_ros_interfaces/msg/detail/publisher_details__traits.hpp"

namespace py_trees_ros_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const IntrospectPublishers_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: publisher_details
  {
    if (msg.publisher_details.size() == 0) {
      out << "publisher_details: []";
    } else {
      out << "publisher_details: [";
      size_t pending_items = msg.publisher_details.size();
      for (auto item : msg.publisher_details) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const IntrospectPublishers_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: publisher_details
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.publisher_details.size() == 0) {
      out << "publisher_details: []\n";
    } else {
      out << "publisher_details:\n";
      for (auto item : msg.publisher_details) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const IntrospectPublishers_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace py_trees_ros_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use py_trees_ros_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const py_trees_ros_interfaces::srv::IntrospectPublishers_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  py_trees_ros_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use py_trees_ros_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const py_trees_ros_interfaces::srv::IntrospectPublishers_Response & msg)
{
  return py_trees_ros_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<py_trees_ros_interfaces::srv::IntrospectPublishers_Response>()
{
  return "py_trees_ros_interfaces::srv::IntrospectPublishers_Response";
}

template<>
inline const char * name<py_trees_ros_interfaces::srv::IntrospectPublishers_Response>()
{
  return "py_trees_ros_interfaces/srv/IntrospectPublishers_Response";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::srv::IntrospectPublishers_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::srv::IntrospectPublishers_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<py_trees_ros_interfaces::srv::IntrospectPublishers_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<py_trees_ros_interfaces::srv::IntrospectPublishers>()
{
  return "py_trees_ros_interfaces::srv::IntrospectPublishers";
}

template<>
inline const char * name<py_trees_ros_interfaces::srv::IntrospectPublishers>()
{
  return "py_trees_ros_interfaces/srv/IntrospectPublishers";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::srv::IntrospectPublishers>
  : std::integral_constant<
    bool,
    has_fixed_size<py_trees_ros_interfaces::srv::IntrospectPublishers_Request>::value &&
    has_fixed_size<py_trees_ros_interfaces::srv::IntrospectPublishers_Response>::value
  >
{
};

template<>
struct has_bounded_size<py_trees_ros_interfaces::srv::IntrospectPublishers>
  : std::integral_constant<
    bool,
    has_bounded_size<py_trees_ros_interfaces::srv::IntrospectPublishers_Request>::value &&
    has_bounded_size<py_trees_ros_interfaces::srv::IntrospectPublishers_Response>::value
  >
{
};

template<>
struct is_service<py_trees_ros_interfaces::srv::IntrospectPublishers>
  : std::true_type
{
};

template<>
struct is_service_request<py_trees_ros_interfaces::srv::IntrospectPublishers_Request>
  : std::true_type
{
};

template<>
struct is_service_response<py_trees_ros_interfaces::srv::IntrospectPublishers_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // PY_TREES_ROS_INTERFACES__SRV__DETAIL__INTROSPECT_PUBLISHERS__TRAITS_HPP_
